/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pb138.dtdToXsd;


import java.util.*;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 *
 * @author Roman
 */

//
public class DTDtoXSDConvertorImpl implements DTDtoXSDConvertor {
       
    //private final static Logger logger = LoggerFactory.getLogger(DTDtoXSDConvertorImpl.class);
    private Document doc;
    private NodeList elements;
    private NodeList attributes;
    private String namespace;
    private Element rootElement;
    private Element tempElement;//samazat,jen pro testovani
    private int uniqueElementNumber = 0;
   
    
    public DTDtoXSDConvertorImpl() throws ParserConfigurationException
    {
        DocumentBuilderFactory dbfac = DocumentBuilderFactory.newInstance();
        DocumentBuilder docBuilder = dbfac.newDocumentBuilder();
        doc = docBuilder.newDocument();
        namespace = "xs:";
        rootElement = doc.createElement(namespace+"schema");
        rootElement.setAttribute("version", "1.0");
        rootElement.setAttribute("xmlns:xs","http://www.w3.org/2001/XMLSchema");
        rootElement.setAttribute("elementFormDefault","qualified");
        doc.appendChild(rootElement);
    }
    
    @Override
    public void convertElements(List<ElementDTD> inputElements) throws XSDConvertException {
        if(inputElements != null)
        {
            //System.out.println("prni element v prevodu "+inputElements.get(inputElements.size()-1));
            for(ElementDTD el: inputElements)
                convertElement(el,null);
        }

    }

    @Override
    public void convertElement(ElementDTD inputElement,Element parentElement) throws XSDConvertException {
        

   
        //pokud je parentElement null, pouzije se koren
        if(parentElement == null)
             parentElement = rootElement;

        
        //reseni category ANY
        if(inputElement.getCategory().equalsIgnoreCase("ANY"))
        {
            Element element = doc.createElement(namespace+"element");
            element.setAttribute("name", inputElement.getElementName());
            Element complexType = doc.createElement(namespace+"complexType");
            complexType.setAttribute("mixed", "true");
            
            Element sequence = doc.createElement(namespace+"sequence");
            Element any = doc.createElement(namespace+"any");
            any.setAttribute("minOccurs", "0");
            any.setAttribute("maxOccurs", "unbounded");
            any.setAttribute("namespace", "##any");
            any.setAttribute("processContents", "skip");
            element.appendChild(complexType);
            complexType.appendChild(sequence);
            sequence.appendChild(any);
            parentElement.appendChild(element);
            return;
        }
        
        
        if(inputElement.getCategory().equalsIgnoreCase("EMPTY"))
        {
            Element element = doc.createElement(namespace+"element");
            element.setAttribute("name", inputElement.getElementName());
            parentElement.appendChild(element);
            return;
        }
        //#PCADATA
        if(inputElement.getCategory().equalsIgnoreCase("(#PCDATA)") || inputElement.getCategory().equalsIgnoreCase("#PCDATA"))
        {
//<xs:element name="prijmeni" minOccurs="0" maxOccurs="1" type="xs:string" />
            //za predpokladu, ze tohle je reprezenatece #PCDATA -                                       dohledat
            //pokud uz je na element odkaz nekde v refu, prepise se na name
            ArrayList<Element> previousDeclarated = findParentInRef(inputElement.getElementName());
            if(previousDeclarated != null)
            {
                for(Element el:previousDeclarated)
                {
                    el.setAttribute("name", inputElement.getElementName());
                    el.removeAttribute("ref");
                    el.setAttribute("type", namespace+"string");
                }
            }else{
                //nenalezeno, vytvari se novy
            Element element = doc.createElement(namespace+"element");
            element.setAttribute("name", inputElement.getElementName());
            element.setAttribute("minOccurs", "0");
            element.setAttribute("maxOccurs", "1");
            element.setAttribute("type", namespace+"string");
            
            parentElement.appendChild(element);
            }
            return;
           
            
        }

        if(inputElement.getCategory().substring(0,1).equals("("))
        {
            inputElement.setLevel(inputElement.getLevel()+1);
            //pokud je level vetsi nez jedna, nevytvari se element, ale pridava se do existujici sequence
            if(inputElement.getLevel() <= 1)
            {
            Element element = doc.createElement(namespace+"element");
            element.setAttribute("name", inputElement.getElementName());
            Element complexType = doc.createElement(namespace+"complexType");
            element.setAttribute("type", inputElement.getElementName()+"_complexType");
            complexType.setAttribute("name",inputElement.getElementName()+"_complexType");
            parentElement.appendChild(element);
            rootElement.appendChild(complexType);
           
            //setElemnetCardinality(element, inputElement.getCategory());
            parseElement(inputElement, complexType);
           
            }
            else{
               // setElemnetCardinality(parentElement, inputElement.getCategory());
                parseElement(inputElement, parentElement);
            }
            
            return;//vetev, ve ktere resi ty regularni vyrazy ci jak to nazva
        }
        
 //predpoklad : pokud nezacina vyraz zavorkou, je v nem prave jeden nazev elementu
         Element element = doc.createElement(namespace+"element");
         Element complexType = doc.createElement(namespace+"complexType");
         element.setAttribute("name", inputElement.getElementName());
         element.setAttribute("type", inputElement.getElementName()+"_complexType");
         complexType.setAttribute("name",inputElement.getElementName()+"_complexType");
         
         
         parentElement.appendChild(element);
         rootElement.appendChild(complexType);
         
         Element sequence = doc.createElement(namespace+"sequence");
         complexType.appendChild(sequence);
         String singleElementName = inputElement.getCategory();
         if(singleElementName.endsWith("+") || singleElementName.endsWith("*") || singleElementName.endsWith("?") || singleElementName.endsWith("&"))
             singleElementName = singleElementName.substring(0, singleElementName.length()-1);
         Element sigleElement = doc.createElement(namespace+"element");
         setElemnetCardinality(sigleElement, inputElement.getCategory());
         sigleElement.setAttribute("ref", singleElementName);
         sequence.appendChild(sigleElement);

    }

    @Override
    public void convertAttributes(List<Attribute> inputAttributes) throws XSDConvertException {
        if(inputAttributes == null)
            return;
        for(Attribute at: inputAttributes)
            convertAttribute(at);
    }

    
    //kazdy atribut je zaklanim tvaru
    @Override
    public void convertAttribute(Attribute inputAttribute)throws XSDConvertException
    {
       if(inputAttribute.getElementName() == null || inputAttribute.getName() == null || 
               inputAttribute.getType() == null)
            throw new XSDConvertException("invalid DTD attlist");
        
         
        //nalezeni rodicovskeho Elementu a pridani atributu do nej,pokud nema complexType, je vytvoren
        ArrayList<Element> parents = findParentElements(inputAttribute.getElementName());
        if(parents == null)
            throw new XSDConvertException("parent element not found");
        //pracuje se jen s prvnim rodicem, pripadni dalsi jsou vyreseni na konci metody
        Element parent = parents.get(0);
        
  
        
        //najde nebo vytvori complexType pro zpracovani attributu        
        Element complexType = null;
        NodeList types = rootElement.getChildNodes();

        for(int i = 0; i!= types.getLength(); i++)
        {
            Element type = (Element)types.item(i);
            if(type.getAttribute("name").equalsIgnoreCase(inputAttribute.getElementName()+"_complexType"))
                complexType = type;
        }
        
        if(complexType == null)
        {
            complexType = doc.createElement(namespace+"complexType");
            complexType.setAttribute("name",inputAttribute.getElementName()+"_complexType");
            rootElement.appendChild(complexType);
        }

        //vytvoreni atributu
        Element attribute = (Element)doc.createElement(namespace + "attribute");
        attribute.setAttribute("name",inputAttribute.getName());

        if(inputAttribute.getFixed() != null)
            attribute.setAttribute("fixed", inputAttribute.getFixed().substring(1,inputAttribute.getFixed().length()-1));

        if(inputAttribute.getDefaultType().equalsIgnoreCase("#REQUIRED"))
            attribute.setAttribute("use", "required");

        if(inputAttribute.getDefaultType().equalsIgnoreCase("#IMPLIED"))
            attribute.setAttribute("use", "optional");
        if(!inputAttribute.getDefaultType().equalsIgnoreCase("#IMPLIED") && !inputAttribute.getDefaultType().equalsIgnoreCase("#REQUIRED")
                    && !inputAttribute.getDefaultType().equalsIgnoreCase("#FIXED"))
            attribute.setAttribute("default", inputAttribute.getDefaultType());
            



            
         //nasteveni typu atributu   
         if(inputAttribute.getType().equalsIgnoreCase("ID"))
             attribute.setAttribute("type", namespace+"ID");
         if(inputAttribute.getType().equalsIgnoreCase("IDREF"))
             attribute.setAttribute("type", namespace+"IDREF");
         if(inputAttribute.getType().equalsIgnoreCase("IDREFS"))
             attribute.setAttribute("type", namespace+"IDREFS");
         if(inputAttribute.getType().equalsIgnoreCase("NMTOKEN"))
             attribute.setAttribute("type", namespace+"NMTOKEN");
         if(inputAttribute.getType().equalsIgnoreCase("NMTOKENS"))
             attribute.setAttribute("type", namespace+"NMTOKENS");
         if(inputAttribute.getType().equalsIgnoreCase("CDATA"))
             attribute.setAttribute("type", namespace+"string");
        
         //zpracovani enumu
         if(inputAttribute.getType().substring(0,1).equals("("))
            {
                //vytvoreni struktury atributu
                Element simpleType = doc.createElement(namespace+"simpleType");
                Element restriction = doc.createElement(namespace+"restriction");
                attribute.appendChild(simpleType);
                simpleType.appendChild(restriction);
                restriction.setAttribute("base", namespace+"string");

                for(String s: getEnumAttributes(inputAttribute.getType()))
                {
                    Element enumration = doc.createElement(namespace+"enumeration");
                    enumration.setAttribute("value", s);
                    restriction.appendChild(enumration);
                }
            }
             
            
                
        Element sibling = findChildrenByName(complexType, namespace+"attribute");
        if(sibling != null)
        {
            sibling.getParentNode().appendChild(attribute);             
        }else{
             if(parent.getAttribute("type").equalsIgnoreCase(namespace+"string"))
                {
                    parent.removeAttribute("type");
                    Element simpleContent = doc.createElement(namespace+"simpleContent");
                    Element extension = doc.createElement(namespace+"extension");
                    complexType.appendChild(simpleContent);
                    extension.setAttribute("base", namespace+"string");
                    simpleContent.appendChild(extension);             
                    extension.appendChild(attribute);
                }
                else
                {
                    complexType.appendChild(attribute);
                }
                parent.setAttribute("type", inputAttribute.getElementName()+"_complexType");
        }



            
            //vsem elementum, ktere maji ref na rodice atributu se nastavi jejich type na vytvoreny 
            //complexType, ktery by ted mel byt validni
            //predpoklad: vsechny elementy se jmenem uvedenym v atributu mely stejny typ    
        for(Element e:parents)
                e.setAttribute("type", inputAttribute.getElementName()+"_complexType");

    }

    @Override
    public void convertComments(List<String> comments)
    {
        if(comments == null)
            return;
        
        Element annotation = doc.createElement(namespace+"annotation");
        rootElement.appendChild(annotation);
        for(String comment: comments)
        {
            Element documentation = doc.createElement(namespace+"documentation");
            documentation.setTextContent(comment);
            annotation.appendChild(documentation);           
        }      
    }
    

    @Override
    public Document convertDTD(List<ElementDTD> elements, List<Attribute> attribute, 
        List<Entity> entities, List<String> comments) throws XSDConvertException {
            convertComments(comments);
            //convertEntities(entities);
            convertElements(elements);
            convertAttributes(attribute);

        
        return doc;
    }
    
//pomocne metody---------------------------------------------------------------------------    
    /**
     * majde a vrati list elementu, ktere maji nazev namespace:element a atribut name roven zadanemu
     * @param parentName
     * @return Element, null if not found
     */
    private ArrayList<Element> findParentElements(String parentName)
    {

        //prepis medoty, vraci primo parent elment
        ArrayList<Element> parents = new ArrayList<>();
        NodeList list = doc.getElementsByTagName(namespace+"element");
        Element parent;
        for(int i = 0; i != list.getLength(); i++)
        {
            parent = (Element)list.item(i);
            if(parent.getAttribute("name").equals(parentName))
                parents.add((Element)list.item(i));
        }
        return parents;
        
    }
    /**
     * metoda pro ziskani enum hodnot u atributu
     * vstup (xxx|sss|eee...)
     * @param enums
     * @return 
     */
    private Set<String> getEnumAttributes(String enums)
    {
        if(enums.length() < 3)
            return null;
        //zbaveni se pocatecni a koncove zavorky    
        enums = enums.substring(1);
        enums = enums.substring(0, enums.length()-1);
        HashSet<String> result = new HashSet<>();       
        result.addAll(Arrays.asList(enums.split("\\|")));
        return result;
        
        
    }    

    //na vstupu bude zpravidla complexType rodicovskeho elementu, pripadne se pouzije root
    public void parseElement(ElementDTD inputElement, Element parentElement) throws XSDConvertException
    {
        int oteviraciZavorky = 0;
        int zaviraciZavorky = 0;
        String kvantifikator;
        if(parentElement == null)
            parentElement = rootElement;

        //projit vyraz a najit vsechny zavorky
        //predpoklada se spravne uzavorkovany vyraz bez mezer

        
  //=================================================================     
        
        //rozkouskovani na uzavorkovane vyrazy a zbytek, se vyskytnul neuzavorkovany element,
        //rozdelen take
        ArrayList<String> vyrazyNaTehleUrovni = new ArrayList<>();
        int zacatekPoslednihoPlatnehoSLova = 0;
        int separatorType = 2; //urcuje typ separovani vyrazu 1 - | nebo  2 - ,
        boolean firstSeparator = true; //prvni separator
        String kvantifikatorVyrazu;
        String originalCategory = inputElement.getCategory();
        
        if(inputElement.getCategory().endsWith(")"))
        {
            //odstraneni zavorek a pridani vodici carka na konec vyrazu        
            inputElement.setCategory(inputElement.getCategory().substring(1, inputElement.getCategory().length()-1));
            inputElement.setCategory(inputElement.getCategory()+",");
            kvantifikatorVyrazu = "&";
        }else{
            kvantifikatorVyrazu = inputElement.getCategory().substring(inputElement.getCategory().length()-1,inputElement.getCategory().length());
            inputElement.setCategory(inputElement.getCategory().substring(1, inputElement.getCategory().length()-2));
            inputElement.setCategory(inputElement.getCategory()+",");  
        }
        for(int i = 1; i <= inputElement.getCategory().length(); i++)
        {
            
            if( inputElement.getCategory().substring(i-1, i).equals("("))
                oteviraciZavorky++;
            if( inputElement.getCategory().substring(i-1, i).equals(")"))
                zaviraciZavorky++;
            
            if(oteviraciZavorky == zaviraciZavorky && (inputElement.getCategory().substring(i-1, i).equals(",") ||
                    inputElement.getCategory().substring(i-1, i).equals("|")))
            {
                if(firstSeparator)
                {
                    if( inputElement.getCategory().substring(i-1, i).equals("|"))
                        separatorType = 1;
                    else
                        separatorType = 2;
                    firstSeparator = false;
                }
                
                String novyVyraz = inputElement.getCategory().substring(zacatekPoslednihoPlatnehoSLova,i-1);
                String novyKvantifikator = novyVyraz.substring(novyVyraz.length()-1, novyVyraz.length());
                
                zacatekPoslednihoPlatnehoSLova = i;
                //posledni znak noveho vyrazu
                //pridani defaultniho kvantifikatoru, pokud se zadny nevyskytuje
                if(!novyKvantifikator.equals("*") && !novyKvantifikator.equals("+") && !novyKvantifikator.equals("?"))
                    novyVyraz = novyVyraz + "&";
                vyrazyNaTehleUrovni.add(novyVyraz);
                
                    
            }
         
        }
        
        //vetev pri separatoru ,
        if(separatorType == 2)
        {
            Element sequence = doc.createElement(namespace+"sequence");
            setElemnetCardinality(sequence, originalCategory);
            parentElement.appendChild(sequence);       
            for(String s: vyrazyNaTehleUrovni)
            {
 
                Element newElement = doc.createElement(namespace+"element");
                setElemnetCardinality(newElement, s);

                //pokud je obsazen slozeny vyraz
                if(s.substring(0, 1).equals("("))
                {
                    String uniqueName = getUniqueElementName();
                    ElementDTD nextElement = new ElementDTD();
                    nextElement.setCategory(s);
                    nextElement.setElementName(uniqueName);
                    nextElement.setLevel(inputElement.getLevel()+1);
                    convertElement(nextElement, sequence);
                    
                }else{
                    //vyraz je primo nazev elementu
                    newElement.setAttribute("ref",s.substring(0,s.length()-1));
                    sequence.appendChild(newElement);
                    
                }
            }
        }
        //vetev pri separatoru |
        if(separatorType == 1)
        {
            Element choice = doc.createElement(namespace+"choice");
            setElemnetCardinality(choice, originalCategory);
            parentElement.appendChild(choice);       
            for(String s: vyrazyNaTehleUrovni)
            {
 
                Element newElement = doc.createElement(namespace+"element");
                setElemnetCardinality(newElement, s);

                //pokud je obsazen slozeny vyraz
                if(s.substring(0, 1).equals("("))
                {
                    String uniqueName = getUniqueElementName();
                    ElementDTD nextElement = new ElementDTD();
                    nextElement.setCategory(s);
                    nextElement.setElementName(uniqueName);
                    nextElement.setLevel(inputElement.getLevel()+1);
                    convertElement(nextElement, choice);
                    
                }else{
                    //vyraz je primo nazev elementu
                    newElement.setAttribute("ref",s.substring(0,s.length()-1));
                    choice.appendChild(newElement);
                    
                }
            }
        }
   
    }
//    kvantifikatory  &-once and only once
//                    *-zero zero of more
//                    +-one or more
//                    ?-zero or one

    //vratin unikatni nazev elementu/////////////////////////////////////////////////doresit
    private String getUniqueElementName()
    {
        return "UniqueElement"+(uniqueElementNumber++);
    }
    
    //vrati NodeList elementu, ktere maji jako ref nastaveny aktualni element
    private ArrayList<Element> findParentInRef(String name)
    {
        NodeList posibleParents = doc.getElementsByTagName(namespace+"element");
        ArrayList<Element> list = new ArrayList<>();
        Element el;
        for(int i = 0; i != posibleParents.getLength(); i++)
        {
            
         el = (Element)posibleParents.item(i);
         if(el.getAttribute("ref").equals(name))
             list.add(el);
             
        }
        if(list.size() > 0)
         return list;
        return null;
        
        
    }
    
    /**
     * medota podle zadaneho vyrazu nastavi elementu atribut minOccures a maxOccures
     * 
     */
    private void setElemnetCardinality(Element inputElement, String expresion)
    {
        if(inputElement == null)
            return;
             
         if(expresion.endsWith("+"))
         {
             inputElement.setAttribute("minOccurs", "1");
             inputElement.setAttribute("maxOccurs", "unbounded");
             return;
         }
         if(expresion.endsWith("*"))
         {
             inputElement.setAttribute("minOccurs", "0");
             inputElement.setAttribute("maxOccurs", "unbounded");
             return;
         }
         if(expresion.endsWith("?"))
         {
             inputElement.setAttribute("minOccurs", "0");
             inputElement.setAttribute("maxOccurs", "1");
             return;
         }

         //pokud nema vyraz nastaveny kvantifikator
             inputElement.setAttribute("minOccurs", "1");
             inputElement.setAttribute("maxOccurs", "1");
         
    }
    
    /**
     * projde rekursivne vsechny potomky daneho elementu a vrati pozadovany element
     * @return Elemenet or null
     */
    private Element findChildrenByName(Element parent, String name)
    {
        NodeList children = parent.getChildNodes();
        Element element;
        for(int i = 0; i != children.getLength(); i++)
        {
            if(children.item(i).getNodeName().equals(name))
                return (Element)children.item(i);
            element = findChildrenByName((Element)children.item(i), name);
            if(element != null)
                return element;
        }
        return null;
    }
    

}








